
//+------------------------------------------------------------------+
//|                                                  MACD Sample.mq4 |
//|                      Copyright  2005, MetaQuotes Software Corp. |
//|                                       http://www.metaquotes.net/ |
//+------------------------------------------------------------------+

extern double TakeProfit = 50;
extern double Lots = 0.1;
extern double TrailingStop = 30;
extern double MACDOpenLevel=3;
extern double MACDCloseLevel=2;
extern double MATrendPeriod=26;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start()
  {
   double MacdCurrent, MacdPrevious,MacdPrevious1, SignalCurrent;
   double SignalPrevious,SignalPrevious1, MaCurrent, MaPrevious;
   bool found;
// initial data checks
// it is important to make sure that the expert works with a normal
// chart and the user did not make any mistakes setting external 
// variables (Lots, StopLoss, TakeProfit, 
// TrailingStop) in our case, we check TakeProfit
// on a chart of less than 100 bars
   if(Bars<100)
     {
      Print("bars less than 100");
      return(0);  
     }
   if(TakeProfit<10)
     {
      Print("TakeProfit less than 10");
      return(0);  // check TakeProfit
     }
// to simplify the coding and speed up access
// data are put into internal variables
   MacdCurrent=iMACD(NULL,0,12,26,9,PRICE_CLOSE,MODE_MAIN,0);
   MacdPrevious=iMACD(NULL,0,12,26,9,PRICE_CLOSE,MODE_MAIN,1);
   MacdPrevious1=iMACD(NULL,0,12,26,9,PRICE_CLOSE,MODE_MAIN,2);
   SignalCurrent=iMACD(NULL,0,12,26,9,PRICE_CLOSE,MODE_SIGNAL,0);
   SignalPrevious=iMACD(NULL,0,12,26,9,PRICE_CLOSE,MODE_SIGNAL,1);
   SignalPrevious1=iMACD(NULL,0,12,26,9,PRICE_CLOSE,MODE_SIGNAL,2);
    
     
      
      if(AccountFreeMargin()<(1000*Lots))
        {
         Print("We have no money. Free Margin = ", AccountFreeMargin());
         return(0);  
        }
      // 
   if(MacdCurrent<SignalCurrent && MacdPrevious>=SignalPrevious && MacdPrevious1>SignalPrevious1)
      { 
       found=false;
       for(int i=OrdersTotal()-1; i>=0; i=i-1)
         {
         OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
         if(OrderSymbol()==Symbol())
           {
           if(OrderType()==OP_BUY)
             OrderClose(OrderTicket(),OrderLots(),Bid,3);
           if(OrderType()==OP_SELL) found=true;
           }
         }
        if(!found) OrderSend(Symbol(),OP_SELL,Lots,Bid,3,0.0,0.0);
      }
    if(MacdCurrent>SignalCurrent && MacdPrevious<=SignalPrevious && MacdPrevious1<SignalPrevious1)
      { 
       found=false;
       for(i=OrdersTotal()-1; i>=0; i=i-1)
         {
         OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
         if(OrderSymbol()==Symbol())
           {
           if(OrderType()==OP_SELL)
             OrderClose(OrderTicket(),OrderLots(),Ask,3);
           if(OrderType()==OP_BUY) found=true;
           }
         }
        if(!found) OrderSend(Symbol(),OP_BUY,Lots,Ask,3,0.0,0.0);
      }     
   return(0);
  }   
   // it is important to enter the market correctly, 
   // but it is more important to exit it correctly...   
// the end.